Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 12413)
+++ trunk/FACT++/gui/design.ui	(revision 12414)
@@ -34,5 +34,5 @@
     </sizepolicy>
    </property>
-   <layout class="QGridLayout" name="gridLayout" rowstretch="0,0">
+   <layout class="QGridLayout" name="gridLayout" rowstretch="0">
     <property name="sizeConstraint">
      <enum>QLayout::SetDefaultConstraint</enum>
@@ -53,5 +53,5 @@
       </property>
       <property name="currentIndex">
-       <number>7</number>
+       <number>6</number>
       </property>
       <property name="documentMode">
@@ -5418,11 +5418,4 @@
                 </property>
                 <layout class="QGridLayout" name="gridLayout_101">
-                 <item row="3" column="0">
-                  <widget class="QPushButton" name="fFeedbackStop">
-                   <property name="text">
-                    <string>Stop</string>
-                   </property>
-                  </widget>
-                 </item>
                  <item row="1" column="0">
                   <widget class="QPushButton" name="fFeedbackOutputDisable">
@@ -5454,4 +5447,34 @@
                    </property>
                   </spacer>
+                 </item>
+                 <item row="3" column="0">
+                  <widget class="QPushButton" name="fFeedbackStop">
+                   <property name="text">
+                    <string>Stop</string>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="4" column="0">
+                  <spacer name="verticalSpacer_85">
+                   <property name="orientation">
+                    <enum>Qt::Vertical</enum>
+                   </property>
+                   <property name="sizeType">
+                    <enum>QSizePolicy::Fixed</enum>
+                   </property>
+                   <property name="sizeHint" stdset="0">
+                    <size>
+                     <width>20</width>
+                     <height>10</height>
+                    </size>
+                   </property>
+                  </spacer>
+                 </item>
+                 <item row="5" column="0">
+                  <widget class="QPushButton" name="fFeedbackCalibrate">
+                   <property name="text">
+                    <string>Calibrate</string>
+                   </property>
+                  </widget>
                  </item>
                 </layout>
@@ -9359,7 +9382,7 @@
               </item>
               <item>
-               <widget class="QCheckBox" name="fAdcStop_2">
+               <widget class="QCheckBox" name="fEventsStop">
                 <property name="enabled">
-                 <bool>false</bool>
+                 <bool>true</bool>
                 </property>
                 <property name="text">
@@ -14278,4 +14301,16 @@
                <enum>QAbstractSpinBox::NoButtons</enum>
               </property>
+              <property name="currentSection">
+               <enum>QDateTimeEdit::HourSection</enum>
+              </property>
+              <property name="displayFormat">
+               <string>hh:mm:ss</string>
+              </property>
+              <property name="calendarPopup">
+               <bool>false</bool>
+              </property>
+              <property name="timeSpec">
+               <enum>Qt::OffsetFromUTC</enum>
+              </property>
               <property name="time">
                <time>
@@ -14284,16 +14319,4 @@
                 <second>0</second>
                </time>
-              </property>
-              <property name="currentSection">
-               <enum>QDateTimeEdit::HourSection</enum>
-              </property>
-              <property name="displayFormat">
-               <string>hh:mm:ss</string>
-              </property>
-              <property name="calendarPopup">
-               <bool>false</bool>
-              </property>
-              <property name="timeSpec">
-               <enum>Qt::OffsetFromUTC</enum>
               </property>
              </widget>
@@ -14420,4 +14443,16 @@
                <enum>QAbstractSpinBox::NoButtons</enum>
               </property>
+              <property name="currentSection">
+               <enum>QDateTimeEdit::HourSection</enum>
+              </property>
+              <property name="displayFormat">
+               <string>hh:mm:ss</string>
+              </property>
+              <property name="calendarPopup">
+               <bool>false</bool>
+              </property>
+              <property name="timeSpec">
+               <enum>Qt::OffsetFromUTC</enum>
+              </property>
               <property name="time">
                <time>
@@ -14426,16 +14461,4 @@
                 <second>0</second>
                </time>
-              </property>
-              <property name="currentSection">
-               <enum>QDateTimeEdit::HourSection</enum>
-              </property>
-              <property name="displayFormat">
-               <string>hh:mm:ss</string>
-              </property>
-              <property name="calendarPopup">
-               <bool>false</bool>
-              </property>
-              <property name="timeSpec">
-               <enum>Qt::OffsetFromUTC</enum>
               </property>
              </widget>
@@ -15516,5 +15539,5 @@
      <y>0</y>
      <width>1436</width>
-     <height>20</height>
+     <height>21</height>
     </rect>
    </property>