Index: trunk/FACT++/src/ftmctrl.cc
===================================================================
--- trunk/FACT++/src/ftmctrl.cc	(revision 12449)
+++ trunk/FACT++/src/ftmctrl.cc	(revision 12450)
@@ -1285,11 +1285,69 @@
     ConnectionDimFTM(ba::io_service& ioservice, MessageImp &imp) :
         ConnectionFTM(ioservice, imp),
-        fDimPassport      ("FTM_CONTROL/PASSPORT",        "X:1;S:1", ""),
-        fDimTriggerRates  ("FTM_CONTROL/TRIGGER_RATES",   "X:2;I:1;F:1;F:40;F:160;F:1;F:1", ""),
+        fDimPassport      ("FTM_CONTROL/PASSPORT",        "X:1;S:1",
+                                                          "Info about the FTM and FPGA version"
+                                                          "|Data0[int]:BoardId, hexCode"
+                                                          "|Data1[int]:DNA of the FTM board"),
+        fDimTriggerRates  ("FTM_CONTROL/TRIGGER_RATES",   "X:1;X:1;I:1;F:1;F:40;F:160;F:1;F:1",
+                                                          "Patch,Board,Camera trigger rates"
+                                                          "|FTMtimeStamp[us]:Time in microseconds, since trigger enabled or disabled"
+                                                          "|OnTimeCounter[us]:Effective on-time, i.e. FTM processes triggers (e.g. No FAD busy)"
+                                                          "|TriggerCounter[int]:Counter of camera trigers (events) since trigger enabled or disabled"
+                                                          "|TriggerRate[Hz]:Trigger rate"
+                                                          "|BoardRate[Hz]:Trigger rate of individual FTUs"
+                                                          "|PatchRate[Hz]:Trigger rate of individual patches"
+                                                          "|ElapsedTime[sec]:Time elapsed since previous report"
+                                                          "|OnTime[sec]:OnTime elapsed since previous report"),
         fDimError         ("FTM_CONTROL/ERROR",           "X:1;S:1;S:28", ""),
-        fDimFtuList       ("FTM_CONTROL/FTU_LIST",        "X:1;X:1;S:1;C:4;X:40;C:40;C:40",  ""),
-        fDimStaticData    ("FTM_CONTROL/STATIC_DATA",     "X:1;S:1;S:1;X:1;S:1;S:3;C:4;S:1;S:1;S:1;S:1;S:1;S:1;I:1;I:8;S:90;S:160;S:40;S:40", ""),
-        fDimDynamicData   ("FTM_CONTROL/DYNAMIC_DATA",    "X:1;X:1;F:4;I:160;I:40;S:40;S:40;S:40;S:1", ""),
-        fDimCounter       ("FTM_CONTROL/COUNTER",         "I:6", ""),
+        fDimFtuList       ("FTM_CONTROL/FTU_LIST",        "X:1;X:1;S:1;C:4;X:40;C:40;C:40",
+                                                          "Logs the changes of status of the FTUs"
+                                                          "|FTMtimeStamp[us]:Time in microseconds"
+                                                          "|ActiveFTU[bitpattern]:Description of enabled FTUs"
+                                                          "|NumBoards[int]:Total number of enabled FTUs"
+                                                          "|NumBoardsCrate[int]:Total number of enabled FTUs per crate"
+                                                          "|DNA[hexCode]:Hex code identifier of FTUs"
+                                                          "|Addr[bitpattern]:Crate address (hardware) of FTUs"
+                                                          "|Ping[int]:Number of pings until FTU response"),
+        fDimStaticData    ("FTM_CONTROL/STATIC_DATA",     "X:1;S:1;S:1;X:1;S:1;S:3;C:4;S:1;S:1;S:1;S:1;S:1;S:1;I:1;I:8;S:90;S:160;S:40;S:40",
+                                                          "Configuration of FTM and FTUs"
+                                                          "|FTMtimeStamp[us]:Time in microseconds, since trigger enabled or disabled"
+                                                          "|GeneralSettings[bitpattern]:Status of the FTM settings (cf. FTM doc)"
+                                                          "|LEDStatus[bitpattern]:Not Used"
+                                                          "|ActiveFTU[bitpattern]:List of enabled FTUs"
+                                                          "|TriggerInterval[bitpattern]:Period of cal. and ped. events (cf. FTM doc)"
+                                                          "|TriggerSeq[int]:Sequence of calib. and pedestal events (LPint, LPext, Ped)"
+                                                          "|LPSettings[bitpattern]:Settings of LP, enabled int, ext, intensity int, ext"
+                                                          "|PhysTrigMult[int]:N for N out of 40 logic on FTM (Physics)"
+                                                          "|CalibTrigMult[int]: N for N out of 40 logic on FTM (Calib)"
+                                                          "|PhysTrigWindow[ns]:Coincidence window for N out of 40 (Physics)"
+                                                          "|CalibTrigWindow[ns]:Coincidence window for N out of 40 (Calib)"
+                                                          "|TrigDelay[ns]:Trigger delay applied on FTM"
+                                                          "|TMDelay[ns]:TM delay applied on FTM"
+                                                          "|DeadTime[ns]:Dead time applied after each event on the FTM"
+                                                          "|ClkCond[bitpattern]:Clock conditionner settings on the FTM (DRS sampling freq.)"
+                                                          "|PixEnabled[bitpattern]:Enabled pixels, pckd in 90 shorts (160*9bits=180bytes)"
+                                                          "|PatchThresh[DACcounts]:Threshold of the trigger patches"
+                                                          "|Multiplicity[DACcounts]:N out of 4 logic settings per FTU"
+                                                          "|Prescaling[500ms]:Update rate of the rate counter"),
+
+        fDimDynamicData   ("FTM_CONTROL/DYNAMIC_DATA",    "X:1;X:1;F:4;I:160;I:40;S:40;S:40;S:40;S:1",
+                                                          "Regular reports sent by FTM"
+                                                          "|FTMtimeStamp[us]:Time in microseconds, since trigger enabled or disabled"
+                                                          "|OnTimeCounter[us]:Ontime, i.e. FTM processes triggers (e.g. No FAD busy)"
+                                                          "|Temperatures[Nan]:not yet defined nor used (wanna be FTM onboard temps)"
+                                                          "|TriggerPatchCounter[int]:trigger patches counting since last update (prescaling)"
+                                                          "|BoardsCounter[int]:FTU board counting after N out of 4 and since last update"
+                                                          "|RateOverflow[bitpattern]:bits 0-4=patches overflow, 5=board overflow, 1 per board"
+                                                          "|Prescaling[500ms]:Update rate of the rate counter"
+                                                          "|CrcError[int]:Number of checksum error in RS485 communication"
+                                                          "|State[int]:State value of the FTM firmware (cf. FTM doc)"),
+        fDimCounter       ("FTM_CONTROL/COUNTER",         "I:1;I:1;I:1;I:1;I:1;I:1",
+                                                          "Communication statistics to or from FTM control and FTM"
+                                                          "|Data0[int]:Num. of headers (any header) received by ftm control"
+                                                          "|Data1[int]:Num. of static data blocks (ftm and ftu settings)"
+                                                          "|Data2[int]:Num. of dynamic data blocks (e.g. rates)"
+                                                          "|Data3[int]:Num. of FTU list (FTU identifiers, answer from ping)"
+                                                          "|Data4[int]:Num. of error messages"
+                                                          "|Data5[int]:Num. of answers from a single register accesess"),
         fTimeStamp(UINT64_MAX),
         fTriggerCounter(UINT32_MAX)